/*
 * HeuristicMonitorView.java
 */
package heuristicmonitor;

import org.jdesktop.application.Action;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import javax.swing.*;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.management.*;

import com.sonicsw.mf.jmx.client.*;
import com.sonicsw.mq.mgmtapi.runtime.*;

import java.io.*;
import java.util.*;
import java.text.*;

/**
 * The application's main frame.
 * @author  rares
 */
public class HeuristicMonitorView extends FrameView
        implements javax.jms.MessageListener {

    Efloys ga = new Efloys();
    cubic c = null;
    MainFrame mf = null;
    int notifications = 0;
    File logFile = null;
    String logFileName = null;
    String absoluteLogFileName = null;
    JMSConnectorClient connector = null;
    private MgmtCLI mgmtcli = null;
    Date now = null;
    private Vector metricsTimes = null;
    private Vector metricsNames = null;
    private Vector metricsValues = null;
    private Vector alertList = new Vector();
    private javax.jms.Connection connect = null;
    private javax.jms.Session subSession = null;
    public String edgeList = new String("");
    /*
     * Constructor
     * @author rares
     */

    public HeuristicMonitorView(SingleFrameApplication app) {
        super(app);

        now = new Date();

        SimpleDateFormat SIMPLE_DATE_FORMAT;
        SIMPLE_DATE_FORMAT = new SimpleDateFormat();
        SIMPLE_DATE_FORMAT.applyPattern("yyyy.MM.dd");
        String date = SIMPLE_DATE_FORMAT.format(now);

        logFileName = "hm-" + date + ".stf";

        File f1 = new File(logFileName);
        absoluteLogFileName = "file:///" + f1.getAbsolutePath();
        absoluteLogFileName = absoluteLogFileName.replace('\\', '/');
        //System.out.println(absoluteLogFileName);

        initComponents();
        // ga
        jPanelEfloy.add(ga);
        ga.init();
        ga.start();


        //connect to Domain
        this.showConnectBox();
        //
        if (subscribeToTracking()) {
            System.out.println("(info): Monitor tracking system is enabled");
        } else {
            System.out.println("(warning): Monitor tracking system is disabled");
            this.jButtonViewTraceBox.setEnabled(false);
        }

    }

    /*
     * Subscribe to all messages from dev.Tracking topic
     */
    public boolean subscribeToTracking() {
        // Create a connection.
        try {

            javax.jms.ConnectionFactory factory;
            factory = (new progress.message.jclient.ConnectionFactory(connectToSonicDialogBox.brokerHostPort));
            connect = factory.createConnection(
                    connectToSonicDialogBox.DefaultUser,
                    connectToSonicDialogBox.DefaultPassword);
            subSession = connect.createSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);
        } catch (javax.jms.JMSException jmse) {
            System.out.println("error: Cannot connect to Broker");
            jmse.printStackTrace();
            return false;
        }

        // Create Subscriber
        try {
            javax.jms.Topic topic = subSession.createTopic(connectToSonicDialogBox.trackingOn);
            javax.jms.MessageConsumer subscriber = subSession.createConsumer(topic);
            subscriber.setMessageListener(this);
            // Now that setup is complete, start the Connection
            connect.start();
        } catch (javax.jms.JMSException jmse) {
            jmse.printStackTrace();
            return false;
        }

        return true;
    } //end subscribeToTracing

    /**
     * Handle the message
     * (as specified in the javax.jms.MessageListener interface).
     */
    @Override
    public void onMessage(javax.jms.Message aMessage) {
        String msgBody = null;
        String msgClass = null;

        if (aMessage instanceof javax.jms.TextMessage) {
            msgClass = "javax.jms.TextMessage";
            try {
                msgBody = ((javax.jms.TextMessage) aMessage).getText();
            } catch (javax.jms.JMSException jmse) {
                msgBody = "";
            }
        } else if (aMessage instanceof javax.jms.BytesMessage) {
            msgClass = "javax.jms.BytesMessage";
            byte[] buffer = new byte[2048];
            byte[] body = new byte[0];
            javax.jms.BytesMessage bytesMessage = (javax.jms.BytesMessage) aMessage;
            try {
                while (true) {
                    int numBytesRead = bytesMessage.readBytes(buffer);
                    if (numBytesRead == -1) {
                        // No more bytes to read.
                        break;
                    }

                    byte[] tmp = new byte[body.length + numBytesRead];
                    System.arraycopy(body, 0, tmp, 0, body.length);
                    System.arraycopy(buffer, 0, tmp, body.length, numBytesRead);
                    body = tmp;
                }
            } catch (javax.jms.JMSException jsme) {
                // Finished reading body.
            }
            msgBody = new String(body);
        } else if (aMessage instanceof javax.jms.MapMessage) {
            msgClass = "javax.jms.MapMessage";
        } else if (aMessage instanceof javax.jms.ObjectMessage) {
            msgClass = "javax.jms.ObjectMessage";
        } else if (aMessage instanceof javax.jms.StreamMessage) {
            msgClass = "javax.jms.StreamMessage";
        } else if (aMessage instanceof progress.message.jclient.XMLMessage) {
            msgClass = "progress.message.jclient.XMLMessage";
            try {
                msgBody = ((progress.message.jclient.XMLMessage) aMessage).getText();
            } catch (javax.jms.JMSException jmse) {
                msgBody = "";
            }
        } else if (aMessage instanceof progress.message.jclient.MultipartMessage) {
            msgClass = "progress.message.jclient.MultipartMessage";
            StringBuffer body = new StringBuffer();
            progress.message.jclient.MultipartMessage mpMessage =
                    (progress.message.jclient.MultipartMessage) aMessage;
            try {
                for (int ip = 0; ip < mpMessage.getPartCount(); ip++) {
                    progress.message.jclient.Part prt = mpMessage.getPart(ip);
                    progress.message.jclient.Header hdr = prt.getHeader();
                    body.append("--- Part " + String.valueOf(ip + 1) + " Headers ---\n");
                    body.append("Content-Type: " + hdr.getContentType() + "\n");
                    if (hdr.getContentId() != null) {
                        body.append("Content-Id: " + hdr.getContentId() + "\n");
                    }
                    java.util.Enumeration hdrFldNames = hdr.getHeaderFieldNames();
                    while (hdrFldNames.hasMoreElements()) {
                        String fld = (String) hdrFldNames.nextElement();
                        body.append(fld + ": " + hdr.getHeaderField(fld) + "\n");
                    }
                    if (hdr.getContentType().startsWith("text/")) {
                        body.append("--- Part " + String.valueOf(ip + 1) + " Content ---\n");
                        body.append(prt.getContent() + "\n");
                    }
                }
            } catch (javax.jms.JMSException jsme) {
                // Finished reading body.
            }
            msgBody = new String(body);
        } else {
            return;
        }

        //get location of rejected message

        //System.out.println(msgBody);
        String containerName = null;
        String processName = null;
        String serviceName = null;

        int i1 = -1;
        int i2 = -1;
        int i3 = -1;

        try {
            if (msgBody.indexOf("XQ_SERVICE_EXCEPTION") > 0) {
                i1 = msgBody.indexOf("container=");
                if (i1 > 0) {
                    containerName =
                            msgBody.substring(i1 + 11, msgBody.indexOf('"', i1 + 11));
                    i2 = msgBody.indexOf("process=");
                    if (i2 > 0) {
                        processName =
                                msgBody.substring(i2 + 9, msgBody.indexOf('"', i2 + 9));

                        i3 = msgBody.indexOf("serviceApplication=");
                        if (i3 > 0) {
                            serviceName =
                                    msgBody.substring(i3 + 20, msgBody.indexOf('"', i3 + 20));

                        }
                    }
                }
            }//if

            //System.out.println(containerName + ":" + processName + ":" + serviceName );

            if (processName == null) {
                processName = "unknown";
            }
            if (serviceName == null) {
                serviceName = "unknown";
            }

            String app = connectToSonicDialogBox.SonicDomain + "-" + containerName;
            if (edgeList.indexOf(app) <= 0) {
                edgeList = edgeList + app + ",";
            }
            app = containerName + "-" + processName;
            if (edgeList.indexOf(app) <= 0) {
                edgeList = edgeList + app + ",";
            }
            app = processName + "-" + serviceName;
            if (edgeList.indexOf(app) <= 0) {
                edgeList = edgeList + app + ",";
            }
            fireEdgeList();
        //System.out.println(edgeList);

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    } //

    /**
     * Disconnect from SonicMQ and quit
     */
    @Action
    public void quit() {
        mgmtcli.exit();
        c.exit();
        try {
            subSession.close();
            connector.disconnect();
        } catch (javax.jms.JMSException jmse) {
            jmse.printStackTrace();
        }
        System.exit(0);
    }

    /**
     * Show Tracing Box
     */
    @Action
    public void showTrackingBox() {
        if (trackingBox == null) {
            JFrame mainFrame = HeuristicMonitorApp.getApplication().getMainFrame();
            trackingBox =
                    new ESBTracingViewBox(mainFrame, false);
            trackingBox.setLocationRelativeTo(mainFrame);
            trackingBox.setEgdes(connectToSonicDialogBox.SonicDomain + "-" +
                    connectToSonicDialogBox.trackingOn + "-OK1," +
                    connectToSonicDialogBox.SonicDomain + "-" +
                    connectToSonicDialogBox.trackingOn + "-OK2");

            trackingBox.setCenter(connectToSonicDialogBox.SonicDomain);
            trackingBox.initGraph();
            HeuristicMonitorApp.getApplication().show(trackingBox);
        } else {
            trackingBox.setVisible(true);
            trackingBox.startMove();
        }

    }
    /*
     * Change the TracingBox data
     */

    public void fireEdgeList() {
        if (trackingBox != null) {
            if (trackingBox.isVisible()) {
                trackingBox.close();
            }
        }
        JFrame mainFrame = HeuristicMonitorApp.getApplication().getMainFrame();
        trackingBox =
                new ESBTracingViewBox(mainFrame, false);
        trackingBox.setLocationRelativeTo(mainFrame);
        trackingBox.setEgdes(edgeList);

        trackingBox.setCenter(connectToSonicDialogBox.SonicDomain);
        trackingBox.initGraph();

    }//fireEdgeList

    /**
     * Show About Box
     */
    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = HeuristicMonitorApp.getApplication().getMainFrame();
            aboutBox =
                    new HeuristicMonitorAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }

        HeuristicMonitorApp.getApplication().show(aboutBox);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jToolBar1 = new javax.swing.JToolBar();
        jButtonWatch = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jButtonViewTraceBox = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        jButtonCubic = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        jButtonExit = new javax.swing.JButton();
        jPanelEfloy = new javax.swing.JPanel();

        mainPanel.setMaximumSize(null);
        mainPanel.setName("mainPanel"); // NOI18N

        jToolBar1.setRollover(true);
        jToolBar1.setName("jToolBar1"); // NOI18N
        jToolBar1.setPreferredSize(null);

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(heuristicmonitor.HeuristicMonitorApp.class).getContext().getActionMap(HeuristicMonitorView.class, this);
        jButtonWatch.setAction(actionMap.get("showParvisMain")); // NOI18N
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(heuristicmonitor.HeuristicMonitorApp.class).getContext().getResourceMap(HeuristicMonitorView.class);
        jButtonWatch.setText(resourceMap.getString("jButtonWatch.text")); // NOI18N
        jButtonWatch.setToolTipText(resourceMap.getString("jButtonWatch.toolTipText")); // NOI18N
        jButtonWatch.setEnabled(false);
        jButtonWatch.setFocusable(false);
        jButtonWatch.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonWatch.setName("jButtonWatch"); // NOI18N
        jButtonWatch.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jButtonWatch);

        jSeparator2.setName("jSeparator2"); // NOI18N
        jToolBar1.add(jSeparator2);

        jButtonViewTraceBox.setAction(actionMap.get("showTrackingBox")); // NOI18N
        jButtonViewTraceBox.setText(resourceMap.getString("jButtonViewTraceBox.text")); // NOI18N
        jButtonViewTraceBox.setToolTipText(resourceMap.getString("jButtonViewTraceBox.toolTipText")); // NOI18N
        jButtonViewTraceBox.setEnabled(false);
        jButtonViewTraceBox.setFocusable(false);
        jButtonViewTraceBox.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonViewTraceBox.setName("jButtonViewTraceBox"); // NOI18N
        jButtonViewTraceBox.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jButtonViewTraceBox);

        jSeparator3.setName("jSeparator3"); // NOI18N
        jToolBar1.add(jSeparator3);

        jButtonCubic.setAction(actionMap.get("showCubic")); // NOI18N
        jButtonCubic.setText(resourceMap.getString("jButtonCubic.text")); // NOI18N
        jButtonCubic.setEnabled(false);
        jButtonCubic.setFocusable(false);
        jButtonCubic.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonCubic.setName("jButtonCubic"); // NOI18N
        jButtonCubic.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jButtonCubic);

        jSeparator1.setName("jSeparator1"); // NOI18N
        jToolBar1.add(jSeparator1);

        jButtonExit.setAction(actionMap.get("quit")); // NOI18N
        jButtonExit.setToolTipText(resourceMap.getString("jButtonExit.toolTipText")); // NOI18N
        jButtonExit.setFocusable(false);
        jButtonExit.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonExit.setName("jButtonExit"); // NOI18N
        jButtonExit.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jButtonExit);

        jPanelEfloy.setMaximumSize(null);
        jPanelEfloy.setName("jPanelEfloy"); // NOI18N

        javax.swing.GroupLayout jPanelEfloyLayout = new javax.swing.GroupLayout(jPanelEfloy);
        jPanelEfloy.setLayout(jPanelEfloyLayout);
        jPanelEfloyLayout.setHorizontalGroup(
            jPanelEfloyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 383, Short.MAX_VALUE)
        );
        jPanelEfloyLayout.setVerticalGroup(
            jPanelEfloyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 206, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanelEfloy, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(182, Short.MAX_VALUE))
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelEfloy, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        setComponent(mainPanel);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Show 2D visualizer tool
     */
    @Action
    public void showParvisMain() {
        UIManager.put("heuristicmonitor.ParallelDisplayUI",
                "heuristicmonitor.BasicParallelDisplayUI");
        if (mf == null) {
            mf = new MainFrame();
            mf.openFile(absoluteLogFileName);
            this.jButtonWatch.setEnabled(false);
        } else {
            mf.setVisible(true);
            mf.refresh();
            this.jButtonWatch.setEnabled(false);
        }
    }

    /**
     * Show connect to Sonic Domain box
     */
    @Action
    public void showConnectBox() {
        if (connectToSonicDialogBox == null) {
            JFrame mainFrame = HeuristicMonitorApp.getApplication().getMainFrame();
            connectToSonicDialogBox = new connectToSonicDialogBox(mainFrame, true);
            connectToSonicDialogBox.setLocationRelativeTo(mainFrame);
        }
        HeuristicMonitorApp.getApplication().show(connectToSonicDialogBox);

        if (connectToSonicDialogBox.getReturnStatus() == 1) {
            connect();
        } //if OK
        else {
            System.exit(1);
        }

    }

    /**
     * connect to SonicMQ
     */
    public void connect() {
        mgmtcli = new MgmtCLI(connectToSonicDialogBox.brokerHostPort,
                connectToSonicDialogBox.DefaultUser, connectToSonicDialogBox.DefaultPassword);
        Long refresh = new Long(connectToSonicDialogBox.RefreshInterval);
        ga.setParent(this);
        ga.setParentSleep(refresh);
    } //connect

    /**
     * Subscribe to all notifications
     */
    private boolean subsribeToAllNotifications(String context) {

        try {
            // NOTIFICATIONS
            Hashtable env = new Hashtable();
            env.put("ConnectionURLs", connectToSonicDialogBox.brokerHostPort);
            env.put("DefaultUser", connectToSonicDialogBox.DefaultUser);
            env.put("DefaultPassword", connectToSonicDialogBox.DefaultPassword);

            JMSConnectorAddress address = new JMSConnectorAddress(env);
            connector = new JMSConnectorClient();
            connector.connect(address, 10000);

            // create a proxy to the broker component
            ObjectName jmxName = new ObjectName(context);
            IBrokerProxy broker = MQProxyFactory.createBrokerProxy(connector, jmxName);

            // create a Sonic expression based filter and setup some filtering rules
            ExpressionBasedNotificationFilter filter = new ExpressionBasedNotificationFilter();
            filter.setTypeExpression(connectToSonicDialogBox.notificationsFilterOn);

            // create a notification listener and subscribe to all notifications from the broker
            NotificationListener notificationListener = new NotificationListener() {

                @Override
                public void handleNotification(Notification notification, Object handback) {
                    showNotification(notification);
                }
            };
            broker.addNotificationListener(notificationListener, filter, "HeuristicMonitor");
        } catch (Exception ex) {
            System.err.println("error");
            return false;
        }
        return true;
    } //subsribeToAllNotifications

    private void addWarning(String s) {

        //add if not exists
        boolean exists = false;
        for (int u = 0; u < alertList.size(); u++) {
            if (alertList.elementAt(u).equals(s)) {
                exists = true;
                break;
            }
        }
        if (!exists) {
            alertList.add(s);
            ga.goStrenger();
            System.out.println(s);
            notifications = notifications + 1;
        }

    }//addWarning

    /**
     * Check container
     */
    private boolean checkContainer(String context) {
        String s = null;
        String s1 = null;
        StringTokenizer st = null;
        StringTokenizer st1 = null;
        String[] metricIds = null;
        String[] metricIds1 = null;
        String retValue = null;
        String retValue1 = null;
        String cntx = null;
        String cntx1 = null;

        String containerName = null;
        String componentName = null;

        cntx = context;

        retValue = mgmtcli.cc(cntx);
        if (retValue != null && retValue.indexOf("error:") == 0) {
            return false;
        }
        retValue = mgmtcli.showStatus(cntx);
        if (!retValue.startsWith("error:")) {
            st = new StringTokenizer(retValue,
                    System.getProperty("line.separator"));
            metricIds = new String[st.countTokens()];
            for (int i = 0; i < metricIds.length; i++) {
                s = st.nextToken();
                if (s.indexOf("Offline") > 0) {
                    addWarning("(warning) " + s);
                } else {
                    if (!s.startsWith("-")) {
                        //is a container
                        containerName = s.substring(0, s.indexOf(" ")).trim();
                        //System.out.println("Container= " + containerName);
                        cntx1 = containerName;

                        retValue1 = mgmtcli.cc(cntx1);
                        if (retValue1 != null && retValue1.indexOf("error:") == 0) {
                            return false;
                        }
                        retValue1 = mgmtcli.showLog(cntx1);
                        if (!retValue1.startsWith("error:")) {
                            st1 = new StringTokenizer(retValue1,
                                    System.getProperty("line.separator"));
                            metricIds1 = new String[st1.countTokens()];
                            for (int j = 0; j < metricIds1.length; j++) {
                                s1 = st1.nextToken();
                                if (s1.indexOf("(severe)") > 0) {
                                    addWarning("(warning) " + s1);
                                }//if
                            }//for
                        }//if

                    } else {
                        //is a component
                        componentName = s.substring(2, s.indexOf(" ", 3)).trim();
                        //skip some components
                        if (!(s.indexOf("MANAGER") > 0 || componentName.equals("DIRECTORY") || componentName.equals("AutoLaunchDaemon"))) {

                            //System.out.println("Component= " + containerName +
                            //   ":ID=" + componentName);
                            checkComponent(containerName + ":ID=" + componentName);
                        }
                    }
                }//else
            }//for
        }//if

        return true;
    } //checkContainer

    /*
     * Return the time format "HH:mm:ss"
     */
    private String getTime() {

        now = new Date();
        SimpleDateFormat SIMPLE_DATE_FORMAT;
        SIMPLE_DATE_FORMAT = new SimpleDateFormat();
        SIMPLE_DATE_FORMAT.applyPattern("HH:mm:ss");
        String time = SIMPLE_DATE_FORMAT.format(now);
        return time;
    }

    /**
     * Check component
     */
    private boolean checkComponent(String context) {
        //get metrics from the component
        String s = null;
        String s1 = null;
        StringTokenizer st = null;
        StringTokenizer st1 = null;
        String[] metricIds = null;
        String[] metricIds1 = null;
        String retValue = null;
        String retValue1 = null;
        String cntx = null;
        long lSum = 0;

        cntx = context;
        try {
            subsribeToAllNotifications(cntx);
        } catch (Exception ex) {
            System.out.println("error" + ex.toString());
        }

        retValue = mgmtcli.cc(cntx);
        if (retValue != null && retValue.indexOf("error:") == 0) {
            System.out.println(retValue);
            System.exit(1);
        }

        //System.out.println(context);
        retValue = mgmtcli.showEnabled(cntx);
        //System.out.println(retValue);
        if (!retValue.startsWith("error:")) {
            st = new StringTokenizer(retValue,
                    System.getProperty("line.separator"));
            metricIds = new String[st.countTokens()];
            for (int i = 0; i < metricIds.length; i++) {
                //if the metric has more instances then
                //we have to make the sum
                s = st.nextToken();
                if (!s.trim().isEmpty()) {
                    if (s.endsWith("*")) {
                        //
                        // Multiple instances
                        //
                        retValue1 = mgmtcli.capture(cntx, s);
                        if (!retValue1.startsWith("error:")) {
                            st1 = new StringTokenizer(retValue1,
                                    System.getProperty("line.separator"));
                            metricIds1 = new String[st1.countTokens()];
                            lSum = 0;
                            for (int i1 = 0; i1 < metricIds1.length; i1++) {
                                s1 = st1.nextToken();
                                if (!s1.trim().isEmpty()) {
                                    /*
                                    System.out.println(
                                    "Name=" +
                                    s1.substring(0,s1.indexOf("=")).trim()
                                    );
                                    System.out.println(
                                    "Value=" +
                                    s1.substring(s1.indexOf("=") + 1 ,
                                    s1.length()).trim()
                                    );
                                     */
                                    try {
                                        Long l = Long.parseLong(s1.substring(s1.indexOf("=") + 1,
                                                s1.length()).trim());
                                        lSum = lSum + l.longValue();
                                    } catch (NumberFormatException nfe) {
                                        System.out.println("NumberFormatException: " + nfe.getMessage());
                                    }

                                }
                            }
                        }
                        //System.out.println(s + "=" + new Long(lSum).toString());
                        metricsTimes.add(getTime());
                        metricsNames.add(s);
                        Long l = new Long(lSum);
                        metricsValues.add((new Integer(l.intValue())).toString());
                    //end multiple instances
                    } else {
                        //System.out.println(s);
                        //System.out.println(mgmtcli.capture(cntx,s));
                        metricsTimes.add(getTime());
                        metricsNames.add(s);
                        String v;
                        v = mgmtcli.capture(cntx, s);
                        String s2 = v.substring(v.indexOf("=") + 1,
                                v.length()).trim();
                        Long l1 = new Long(s2);
                        metricsValues.add((new Integer(l1.intValue())).toString());

                    }//else
                }//not empty
            } //for metrics list
        } //if

        return true;
    }//checkComponent


    /**
     * Reads on line, skipping comments and empty lines.
     */
    protected String readLine(Reader in) throws IOException{
        char buf[] = new char[128];
        int offset = 0;
        int ch;
        boolean skip = false;
        for (;;) {
            ch = in.read();

            if (ch == -1){
                break;
            }
            if (ch == '\n' || ch == '\r') {
                if (offset == 0 && !skip){
                    skip = true;
                }
                if (skip){
                    skip = false;
                }
                else {
                    break;
                }
            }
            else if(ch == '#' && offset == 0){
                skip = true;
            }
            else if (!skip){
                if (offset == buf.length) {
                    char tmpbuf[] = buf;
                    buf = new char[tmpbuf.length * 2];
                    System.arraycopy(tmpbuf, 0, buf, 0, offset);
                }
                buf[offset++] = (char) ch;
            }
        }
        if ((offset == 0) || skip){ //eof
            return null;
        }
        return String.copyValueOf(buf, 0, offset);
    }

    /**
     * method fired by Floys
     * create the file *.stf used by 2D visualizer
     */
    public void shwoMetrics() {
        //reinitalise metrics
        metricsTimes = new Vector();
        metricsNames = new Vector();
        metricsValues = new Vector();

        String s = null;
        String retValue = null;
        String cntx = null;
        
        //get the domain configuration
        cntx = connectToSonicDialogBox.SonicDomain;

        retValue = mgmtcli.cc(cntx);
        if (retValue != null && retValue.indexOf("error:") == 0) {
            System.out.println(retValue);
            System.exit(1);
        }
        if (!checkContainer(cntx)) {
            System.exit(1);
        }

        //adding notifications

        //System.out.println("adding notifications");
        Integer nb = new Integer(notifications);
        metricsTimes.add(getTime());
        metricsNames.add("Notifications");
        metricsValues.add(nb.toString());

        // Add other Dimensions like %CPU %MEM
        if (isLinux()) {
            addOSMetrics("linux-monitor.sh");
        } //end if linux
        if (isAIX()) {
            addOSMetrics("aix-monitor.sh");
        } //end if linux
        
        
        Integer cntI = new Integer(metricsNames.size() + 1);
        if (cntI.intValue() == 2) {
            System.out.println("error: no metrics enabled.");
            System.exit(1);
        }

        logFile = new File(logFileName);
        FileOutputStream fl = null;
        FileReader fr = null;
        PrintWriter logFileOut = null;
        String line = null;

        try {
            if (!logFile.exists()) {
                logFile.createNewFile();
                logFileOut = new PrintWriter(logFile);
                //print the number of dimentions
                logFileOut.println(cntI.toString());
                logFileOut.println("time string");
                for (int i = 0; i < metricsNames.size(); i++) {
                    logFileOut.println(
                            (String) metricsNames.elementAt(i) + " real");
                }//for
                logFileOut.close();
            } //file not exists
            // if file exist then check the total metrics
            // on the first line
            fr = new FileReader(logFile);
            String nbMetrics = readLine(fr);
            Integer iNbMetrics = new Integer(nbMetrics);
            fr.close();

            if (iNbMetrics.intValue() != metricsValues.size()+1 ) {
             addWarning("(severe) Mismatch number of metrics, " +
                     "may be a container is shutdown");
             return;
            }

            fl = new FileOutputStream(logFileName, true);
            line = (metricsTimes.elementAt(0)).toString() + " ";
            for (int i = 0; i < metricsValues.size(); i++) {
                line = line + (String) metricsValues.elementAt(i) + " ";
            }//for
            line = line.trim();
            fl.write(line.getBytes());
            fl.write(System.getProperty("line.separator").getBytes());
            fl.flush();
            fl.close();

        } catch (java.io.IOException ex) {
            ex.printStackTrace();
        }


        //reset values
        notifications = 0;
        //fire refresh in MainFrame
        if (mf == null) {
            this.showParvisMain();
            mf.setVisible(false);
            this.jButtonWatch.setEnabled(true);
        } else {
            if (mf.isVisible()) {
                mf.refresh();
            } else {
                this.jButtonWatch.setEnabled(true);
            }
        }
        //rs FIXME!
        if (c == null) {
           this.jButtonCubic.setEnabled(true);
        } else {
           this.jButtonCubic.setEnabled(false);
        }

        if(trackingBox != null) {
          if (!trackingBox.isVisible()) {
            this.jButtonViewTraceBox.setEnabled(true);
          }
        } else {
          this.jButtonViewTraceBox.setEnabled(true);
         }
        
        //force refresh
        System.gc();

    } //end shwoMetrics

    /*
     * Check if the oprating system is Linux
     */
    
    private boolean isLinux () {
      if (System.getProperty("os.name").equals("Linux")) {
          return true;
      }  
      return false;
    }
    
    /*
     * Check if the oprating system is IBM-AIX 
     */
      
    private boolean isAIX () {
      if (System.getProperty("os.name").equals("AIX")) {
          return true;
      }  
      return false;
    }
    
    /*
     * add %CPU and %MEM from Operating system 
     */
      
    private void addOSMetrics( String shellScript) {
         try {               
             //the script write into a temporary file o.txt
             Process xCmd = Runtime.getRuntime().exec(shellScript);
             Float sumCPU = new Float(0);
             Float sumMEM = new Float(0);
             
             if (xCmd.waitFor() == 0) {
                 //now read this file and delete it
                 File oFile = new File("o.txt");
                 FileReader ofr = new FileReader(oFile);
                 String oLine = "";
                 
                 metricsTimes.add(getTime());
                 metricsNames.add("%CPU");
                 metricsTimes.add(getTime());
                 metricsNames.add("%MEM");
                 int nbProcess = 0;
                 while (true) {
                     oLine = readLine(ofr);
                     if(oLine!=null) {
                         StringTokenizer ost = new StringTokenizer(oLine," ");
                         sumCPU = sumCPU + new Float(ost.nextToken().trim());
                         sumMEM = sumMEM + new Float(ost.nextToken().trim());
                         nbProcess++;
                     }
                     else break;
                 } //while read    
                 //round values
                 Integer isumCPU = new Integer(sumCPU.intValue()/nbProcess);
                 Integer isumMEM = new Integer(sumMEM.intValue()/nbProcess);
                 metricsValues.add(isumCPU.toString());
                 metricsValues.add(isumMEM.toString());
                 
                 ofr.close();
                 oFile.delete();
             }   
         } catch (Exception ex) {
           System.err.println("Monitor script execution failed \n" +
                   ex.toString());
         }
        
    } //
    
    /**
     * get notifications from broker(s)
     */
    public void showNotification(Notification notification) {
        /*
        System.out.println("notification=" +
        notification.getType() + ", source=" + notification.getSource());
         */
        notifications = notifications + 1;
        /*System.out.println("notification=" +
        notification.getType());
         */
        /*
        HashMap attributes = ((INotification) notification).getAttributes();
        Iterator iterator = attributes.entrySet().iterator();
        while (iterator.hasNext()) {
        Map.Entry entry = (Map.Entry) iterator.next();
        System.out.println("\t" + entry.getKey() + "=" + entry.getValue());
        }
         */
        ga.goStrenger();
    } //showNotification

    @Action
    public void showCubic() {
        c = new cubic();
        c.main(new String[] { "heuristicmonitor.cubic", logFileName });
        jButtonCubic.setEnabled(false);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCubic;
    private javax.swing.JButton jButtonExit;
    private javax.swing.JButton jButtonViewTraceBox;
    private javax.swing.JButton jButtonWatch;
    private javax.swing.JPanel jPanelEfloy;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JPanel mainPanel;
    // End of variables declaration//GEN-END:variables
    private connectToSonicDialogBox connectToSonicDialogBox;
    private JDialog aboutBox;
    private ESBTracingViewBox trackingBox;
}
