/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package heuristicmonitor;

/**
 *
 * @author rares
 */
public class QReceiver
    implements javax.jms.MessageListener
{
    private static final String DEFAULT_BROKER_NAME = "localhost:2506";
    private static final String DEFAULT_PASSWORD = "Administrator";
    private static final String DEFAULT_USER = "Administrator";
    private static final String DEFAULT_QUEUE = "SampleQ1";

    private javax.jms.Connection connect = null;
    private javax.jms.Session receiveSession = null;

    /** Create JMS client for sending and receiving messages. */
    private void talker( String broker, String username, 
            String password,  String rQueue)
    {
        // Create a connection.
        try
        {
            javax.jms.ConnectionFactory factory;
            factory = (new progress.message.jclient.ConnectionFactory (broker));
            connect = factory.createConnection (username, password);
            receiveSession = connect.createSession(false,javax.jms.Session.AUTO_ACKNOWLEDGE);
        }
        catch (javax.jms.JMSException jmse)
        {
            System.err.println("error: Cannot connect to Broker - " + broker);
            jmse.printStackTrace();
            System.exit(1);
        }

        // Create Sender and Receiver 'Talk' queues
        try
        {
            if (rQueue != null)
            {
                javax.jms.Queue receiveQueue = receiveSession.createQueue (rQueue);
                javax.jms.MessageConsumer qReceiver = receiveSession.createConsumer(receiveQueue);
                qReceiver.setMessageListener(this);
                // Now that 'receive' setup is complete, start the Connection
                connect.start();
            }
        }
        catch (javax.jms.JMSException jmse)
        {
            jmse.printStackTrace();
            exit();
        }
    }

    /**
     * Handle the message
     * (as specified in the javax.jms.MessageListener interface).
     */
    public void onMessage( javax.jms.Message aMessage)
    {
        try
        {
            // Cast the message as a text message.
            javax.jms.TextMessage textMessage = (javax.jms.TextMessage) aMessage;

            // This handler reads a single String from the
            // message and prints it to the standard output.
            try
            {
                String string = textMessage.getText();
                System.out.println( string );
            }
            catch (javax.jms.JMSException jmse)
            {
                jmse.printStackTrace();
            }
        }
        catch (java.lang.RuntimeException rte)
        {
            rte.printStackTrace();
        }
    }

    /** Cleanup resources and then exit. */
    private void exit()
    {
        try
        {
            connect.close();
        }
        catch (javax.jms.JMSException jmse)
        {
            jmse.printStackTrace();
        }

        System.exit(0);
    }

    //
    // NOTE: the remainder of this sample deals with reading arguments
    // and does not utilize any JMS classes or code.
    //

    /** Main program entry point. */
    public static void main(String argv[]) {

        // Values to be read from parameters
        String broker    	= DEFAULT_BROKER_NAME;
        String username  	= DEFAULT_USER;
        String password  	= DEFAULT_PASSWORD;
        String qReceiver	= DEFAULT_QUEUE;

        // Start the JMS client for the "Talk".
        QReceiver talk = new QReceiver();
        talk.talker (broker, username, password, qReceiver);

    } //main


} //class

