/*
 * Publish 1 milion des messages to topic Sample.T1
 */
package heuristicmonitor;

/**
 *
 * @author rares
 */
public class TPublisher {

    private static final String DEFAULT_BROKER_NAME = "localhost:2506";
    private static final String DEFAULT_PASSWORD = "Administrator";
    private static final String DEFAULT_USER = "Administrator";
    private static final String APP_TOPIC = "Sample.T01";
    private static final int NUM_MESSAGES = 1000000;
    private javax.jms.Connection connect = null;
    private javax.jms.Session pubSession = null;
    private javax.jms.MessageProducer publisher = null;

    /** Create JMS client for publishing and subscribing to messages. */
    private void chatter(String broker, String username, String password) {
        // Create a connection.
        try {
            javax.jms.ConnectionFactory factory;
            factory = (new progress.message.jclient.ConnectionFactory(broker));
            connect = factory.createConnection(username, password);
            pubSession = connect.createSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);
        } catch (javax.jms.JMSException jmse) {
            System.err.println("error: Cannot connect to Broker - " + broker);
            jmse.printStackTrace();
            System.exit(1);
        }

        // Create Publisher and Subscriber to 'chat' topics
        try {
            javax.jms.Topic topic = pubSession.createTopic(APP_TOPIC);
            publisher = pubSession.createProducer(topic);
            // Now that setup is complete, start the Connection
            connect.start();
        } catch (javax.jms.JMSException jmse) {
            jmse.printStackTrace();
        }

        try {

            for (int i = 0; i < NUM_MESSAGES; i++) {
                javax.jms.TextMessage msg = pubSession.createTextMessage();
                msg.setText(
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" +
                        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
                publisher.send(msg);
            }
        } catch (javax.jms.JMSException jmse) {
            jmse.printStackTrace();
        }
        exit();
    }

    /** Cleanup resources and then exit. */
    private void exit() {
        try {
            connect.close();
        } catch (javax.jms.JMSException jmse) {
            jmse.printStackTrace();
        }

        System.exit(0);
    }

    //
    // NOTE: the remainder of this sample deals with reading arguments
    // and does not utilize any JMS classes or code.
    //
    /** Main program entry point. */
    public static void main(String argv[]) {

        // Values to be read from parameters
        String broker = DEFAULT_BROKER_NAME;
        String username = DEFAULT_USER;
        String password = DEFAULT_PASSWORD;

        // Start the JMS client for the "chat".
        TPublisher chat = new TPublisher();
        chat.chatter(broker, username, password);

    }
}//class
