/*
 * connectToSonicDialogBox.java
 *
 * Created on 13 août 2008, 15:02
 */

package heuristicmonitor;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;


/**
 * Show a JDialog for SonicMQ connection details
 * @author  rares
 */
public class connectToSonicDialogBox extends javax.swing.JDialog {
    /** A return status code - returned if Cancel button has been pressed */
    public static final int RET_CANCEL = 0;
    /** A return status code - returned if OK button has been pressed */
    public static final int RET_OK = 1;
    public    String SonicDomain = "Domain1";
    public    String brokerHostPort = "tcp://localhost:2506";
    public    String DefaultUser = "Administrator";
    public    String DefaultPassword = "Administrator";
    public    String RefreshInterval = "500";
    public    String trackingOn="dev.Tracking";
    public    String notificationsFilterOn="application\\.connection";

    
    /** Creates new form connectToSonicDialogBox */
    public connectToSonicDialogBox(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        
        try {    
            String propertiesFile = DEFAULT_PROPERTIES_FILE;
            Properties properties = new Properties();
            propertiesFile = System.getProperty("propertiesFile", propertiesFile);
            properties.load(new FileInputStream(propertiesFile));

            // Connection Properties
            SonicDomain = properties.getProperty("SonicDomain",SonicDomain).trim(); 
            jTextFieldDomain.setText(SonicDomain);
            brokerHostPort = properties.getProperty("brokerHostPort",brokerHostPort).trim(); 
            jTextFieldURL.setText(brokerHostPort);
            DefaultUser = properties.getProperty("DefaultUser",DefaultUser).trim(); 
            jTextFieldUser.setText(DefaultUser);
            DefaultPassword = properties.getProperty("DefaultPassword",DefaultPassword).trim(); 
            jPasswordField.setText(DefaultPassword);
            RefreshInterval = properties.getProperty("RefreshInterval",RefreshInterval).trim(); 
            jTextFieldRefresh.setText(RefreshInterval);
            //other variables
            trackingOn = properties.getProperty("trackingOn",trackingOn).trim(); 
            notificationsFilterOn = properties.getProperty("notificationsFilterOn",notificationsFilterOn).trim(); 
            
            
            this.repaint();
            
        }
        catch (java.io.FileNotFoundException fnfe)
        {
            System.out.println ("1) properties file not found: using defaults");
        }
        catch (java.io.IOException ioe)
        {
            System.out.println ("2) properties file not found: using defaults");
            ioe.printStackTrace();
        }                
        
    }

    /** @return the return status of this dialog - one of RET_OK or RET_CANCEL */
    public int getReturnStatus() {
        return returnStatus;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldURL = new javax.swing.JTextField();
        jTextFieldUser = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jPasswordField = new javax.swing.JPasswordField();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldDomain = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldRefresh = new javax.swing.JTextField();

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(heuristicmonitor.HeuristicMonitorApp.class).getContext().getResourceMap(connectToSonicDialogBox.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText(resourceMap.getString("okButton.text")); // NOI18N
        okButton.setToolTipText(resourceMap.getString("okButton.toolTipText")); // NOI18N
        okButton.setName("okButton"); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(resourceMap.getString("cancelButton.text")); // NOI18N
        cancelButton.setToolTipText(resourceMap.getString("cancelButton.toolTipText")); // NOI18N
        cancelButton.setName("cancelButton"); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jTextFieldURL.setText(resourceMap.getString("jTextFieldURL.text")); // NOI18N
        jTextFieldURL.setToolTipText(resourceMap.getString("jTextFieldURL.toolTipText")); // NOI18N
        jTextFieldURL.setName("jTextFieldURL"); // NOI18N
        jTextFieldURL.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldURLActionPerformed(evt);
            }
        });

        jTextFieldUser.setText(resourceMap.getString("jTextFieldUser.text")); // NOI18N
        jTextFieldUser.setToolTipText(resourceMap.getString("jTextFieldUser.toolTipText")); // NOI18N
        jTextFieldUser.setName("jTextFieldUser"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jPasswordField.setText(resourceMap.getString("jPasswordField.text")); // NOI18N
        jPasswordField.setToolTipText(resourceMap.getString("jPasswordField.toolTipText")); // NOI18N
        jPasswordField.setName("jPasswordField"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        jTextFieldDomain.setText(resourceMap.getString("jTextFieldDomain.text")); // NOI18N
        jTextFieldDomain.setToolTipText(resourceMap.getString("jTextFieldDomain.toolTipText")); // NOI18N
        jTextFieldDomain.setName("jTextFieldDomain"); // NOI18N

        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        jTextFieldRefresh.setText(resourceMap.getString("jTextFieldRefresh.text")); // NOI18N
        jTextFieldRefresh.setName("jTextFieldRefresh"); // NOI18N
        jTextFieldRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldRefreshActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel6)
                            .addComponent(jLabel2)
                            .addComponent(jLabel1)
                            .addComponent(jLabel4))
                        .addGap(12, 12, 12)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jTextFieldRefresh, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                        .addComponent(jTextFieldUser, javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jPasswordField, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addComponent(jTextFieldDomain, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextFieldURL, javax.swing.GroupLayout.PREFERRED_SIZE, 172, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(75, 75, 75)
                        .addComponent(okButton)
                        .addGap(23, 23, 23)
                        .addComponent(cancelButton)))
                .addContainerGap(30, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jTextFieldDomain, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldURL, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextFieldUser, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jPasswordField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldRefresh, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton)
                    .addComponent(okButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed

        try {    
            String propertiesFile = DEFAULT_PROPERTIES_FILE;
            Properties properties = new Properties();
            propertiesFile = System.getProperty("propertiesFile", propertiesFile);
            properties.setProperty("brokerHostPort", jTextFieldURL.getText());
            properties.setProperty("SonicDomain", jTextFieldDomain.getText());
            properties.setProperty("DefaultUser", jTextFieldUser.getText());
            properties.setProperty("DefaultPassword", jPasswordField.getText());
            properties.setProperty("RefreshInterval", jTextFieldRefresh.getText());
            //other
            properties.setProperty("trackingOn", trackingOn);
            properties.setProperty("notificationsFilterOn", notificationsFilterOn);

            FileOutputStream out =  new FileOutputStream(propertiesFile);
            properties.save(out, propertiesFile);
            
            
        }
        catch (java.io.FileNotFoundException fnfe)
        {
            System.out.println ("File not found " + fnfe.toString());
        }
        catch (java.io.IOException ioe)
        {
            System.out.println ("IO error " + ioe.toString());
            ioe.printStackTrace();
        }                
        
        
        doClose(RET_OK);
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

private void jTextFieldURLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldURLActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jTextFieldURLActionPerformed

private void jTextFieldRefreshActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldRefreshActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jTextFieldRefreshActionPerformed

    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                connectToSonicDialogBox dialog = new connectToSonicDialogBox(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPasswordField jPasswordField;
    private javax.swing.JTextField jTextFieldDomain;
    private javax.swing.JTextField jTextFieldRefresh;
    private javax.swing.JTextField jTextFieldURL;
    private javax.swing.JTextField jTextFieldUser;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

    private static final String DEFAULT_PROPERTIES_FILE = "HeuristicMonitor.properties";
    private int returnStatus = RET_CANCEL;
}
